# Copyright 2019-present Lenovo
# Confidential and Proprietary

from resoure import DeployServiceRunner


def create_app():
    import os

    import falcon

    api = falcon.API()

    api.req_options.strip_url_path_trailing_slash = True
    scenario = os.environ.get('LETRAIN_SCENARIO', '')
    model_path = os.environ.get('LETRAIN_MODEL_PATH', '')
    model_name = os.environ.get('LETRAIN_MODEL_NAME', '')
    service_uuid = os.environ.get('SERVICE_UUID', '')
    service_url = os.environ.get('SERVICE_URL', '')
    text_max_seq_length = os.environ.get('TEXT_MAX_SEQ_LENGTH', '')
    text_language = os.environ.get('TEXT_LANGUAGE', '')
    text_lower_case = os.environ.get('TEXT_LOWER_CASE', '')
    if service_uuid:
        service_url = '/internal_api/service/{0}'.format(service_uuid)
    api.add_route(
        service_url,
        DeployServiceRunner(scenario, model_path, model_name,
                            language=text_language,
                            do_lower_case=text_lower_case,
                            max_seq_length=text_max_seq_length)
    )

    return api
