# Copyright 2022-present Lenovo
# Confidential and Proprietary
import importlib
import tensorflow.compat.v1 as tf
tf.disable_v2_behavior()


def run_export_model(scenario, **kwargs):
    try:
        service_mgt = importlib.import_module(scenario)
        export_service_mgt = getattr(service_mgt, 'ExportService')
        print("Export model scenario : {}".format(scenario))
    except Exception as e:
        raise e

    try:
        export_service_mgt().checkpoint2pb()
    except Exception as e:
        raise e


if __name__ == '__main__':
    tf.app.flags.DEFINE_enum(
        'scenario', 'image_classification',
        ['image_classification',
         'object_detection',
         'instance_segmentation',
         'medical_image_segmentation',
         'text_classification'],
        "Scenario for this service"
    )
    tf.app.flags.DEFINE_string(
        'lico_checkpoint_dir', '',
        "checkpoint dir path, for load checkpoint files"
    )
    tf.app.flags.DEFINE_string(
        'lico_pb_path', '', "pb file dir, for save pb file"
    )
    tf.app.flags.DEFINE_string('lico_model_name', '',
                               "model_name for export job")
    tf.app.flags.DEFINE_integer("model_version", 1, "the number of model"
                                "version")
    tf.app.flags.DEFINE_boolean('lico_version_control', True, "auto count "
                                                              "version or not")
    tf.app.flags.DEFINE_boolean('lico_text_lower_case', True, "text for "
                                                              "do_lower_case")
    tf.app.flags.DEFINE_enum('lico_text_language', 'en', ['en', 'zh'],
                             'text for language')
    tf.app.flags.DEFINE_string("lico_text_content", "", "text content")
    tf.app.flags.DEFINE_integer('lico_text_max_seq_length', 256,
                                "text for max_seq_length")
    FLAGS = tf.app.flags.FLAGS

    run_export_model(FLAGS.scenario)
